(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core')) :
    typeof define === 'function' && define.amd ? define('ngx-mask-input', ['exports', '@angular/core'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory(global['ngx-mask-input'] = {}, global.ng.core));
}(this, (function (exports, core) { 'use strict';

    var NgxMaskInputDirective = /** @class */ (function () {
        function NgxMaskInputDirective() {
            //
            this.mask = '.';
        }
        //
        NgxMaskInputDirective.prototype.onKeyPress = function ($event) {
            return this.filterInput($event);
        };
        //
        NgxMaskInputDirective.prototype.onPaste = function ($event) {
            return this.filterInput($event);
        };
        //
        NgxMaskInputDirective.prototype.filterInput = function (event) {
            var _this = this;
            var $input = event._input || event.target;
            if (event.ctrlKey || event.altKey) {
                return;
            }
            var value = null;
            var regex = null;
            switch (event._type || event.type) {
                case 'keypress':
                    var pressedKey = event.charCode || event.keyCode || 0;
                    if (pressedKey === 13) {
                        return true;
                    }
                    if ([8, 9, 13, 35, 36, 37, 39, 46].indexOf(pressedKey) > -1) {
                        if (event.charCode === 0 && event.keyCode === pressedKey) {
                            return true;
                        }
                    }
                    value = String.fromCharCode(pressedKey);
                    regex = new RegExp(this.mask);
                    break;
                case 'paste':
                    $input.dataset.value_before_paste = event.target.value;
                    setTimeout(function () {
                        event._type = 'after_paste';
                        event._input = $input;
                        _this.filterInput(event);
                    }, 0);
                    return true;
                case 'after_paste':
                    value = $input.value;
                    regex = new RegExp("^(" + this.mask + ")+$");
                    break;
                default:
                    event.preventDefault();
                    return false;
            }
            if (regex.test(value)) {
                return true;
            }
            if (event._type === 'after_paste') {
                $input.value = $input.dataset.value_before_paste;
            }
            event.preventDefault();
            return false;
        };
        return NgxMaskInputDirective;
    }());
    NgxMaskInputDirective.decorators = [
        { type: core.Directive, args: [{
                    selector: 'input[mask]'
                },] }
    ];
    NgxMaskInputDirective.propDecorators = {
        mask: [{ type: core.Input }],
        onKeyPress: [{ type: core.HostListener, args: ['keypress', ['$event'],] }],
        onPaste: [{ type: core.HostListener, args: ['paste', ['$event'],] }]
    };

    var NgxMaskInputModule = /** @class */ (function () {
        function NgxMaskInputModule() {
        }
        return NgxMaskInputModule;
    }());
    NgxMaskInputModule.decorators = [
        { type: core.NgModule, args: [{
                    declarations: [NgxMaskInputDirective],
                    exports: [NgxMaskInputDirective]
                },] }
    ];

    /*
     * Public API Surface of ngx-mask-input
     */

    /**
     * Generated bundle index. Do not edit.
     */

    exports.NgxMaskInputDirective = NgxMaskInputDirective;
    exports.NgxMaskInputModule = NgxMaskInputModule;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=ngx-mask-input.umd.js.map
